import pytest

from util.config.validators import ConfigValidationException
from util.config.validators.registrystorage import StorageValidator

@pytest.mark.parametrize('unvalidated_config, expected', [
  ({}, ConfigValidationException),
  ({'DISTRIBUTED_STORAGE_CONFIG': {}}, ConfigValidationException),
  ({'DISTRIBUTED_STORAGE_CONFIG': {'local': None}}, ConfigValidationException),
  ({'DISTRIBUTED_STORAGE_CONFIG': {'local': ['FakeStorage', {}]}}, None),
])
def test_validate_storage(unvalidated_config, expected):
  validator = StorageValidator()
  if expected is not None:
    with pytest.raises(expected):
      validator.validate(unvalidated_config, None, None)
  else:
    validator.validate(unvalidated_config, None, None)
